
local _, YssInstanceMaps = ...

if not YssInstanceMaps then
	_GYssInstanceMaps = _GYssInstanceMaps or {}
	YssInstanceMaps = _GYssInstanceMaps
end

local BZ = LibStub("LibBabble-Zone-3.0", true):GetLookupTable()

------------------------------------------------------------
-------------------------Map Types--------------------------
------------------------------------------------------------
YssInstanceMaps.MapTypes = {
	['Dungeon'] = 'Dungeon',
	['Raid'] = 'Raid',
	['Battlegrounds'] = BATTLEGROUNDS,
}

------------------------------------------------------------
----------------------Map Textures--------------------------
------------------------------------------------------------
YssInstanceMaps.Maps = {}
YssInstanceMaps.Maps.Dungeon = {
	["Ahn'kahet: The Old Kingdom"] = 'AhnKahet',
	["Azjol-Nerub"] = 'AzjolNerub',
	["Drak'Tharon Keep"] = 'DrakTharonKeep',
	["Gundrak"] = 'GunDrak',
	["Halls of Lightning"] = 'HallsofLightning',
	["Halls of Stone"] = 'Ulduar77', -- Great Name Blizz
	["The Culling of Stratholme"] = 'CoTStratholme',
	["The Nexus"] = 'TheNexus',
	["The Oculus"] = 'Nexus80', -- Great Name Blizz
	["The Violet Hold"] = 'VioletHold',
	["Utgarde Keep"] = 'UtgardeKeep',
	["Utgarde Pinnacle"] = 'UtgardePinnacle',
	["Trial of the Champion"] = 'TheArgentColiseum',
	["The Forge of Souls"] = 'TheForgeofSouls',
	["Pit of Saron"] = 'PitofSaron',
	["Halls of Reflection"] = 'HallsofReflection',
}

YssInstanceMaps.Maps.Raid = {
	["Icecrown Citadel"] = 'IcecrownCitadel',
	["Naxxramas"] = 'Naxxramas',
	["The Eye of Eternity"] = 'EyeOfEternity',
	["The Obsidian Sanctum"] = 'TheObsidianSanctum',
	["Ulduar"] = 'Ulduar',
	["Vault of Archavon"] = 'VaultofArchavon',
	["Trial of the Crusader"] = 'TheArgentColiseum',
}

YssInstanceMaps.Maps.Battlegrounds = {
	["Alterac Valley"] = 'AlteracValley',
	["Arathi Basin"] = 'ArathiBasin',
	["Eye of the Storm"] = 'NetherstormArena',
	["Strand of the Ancients"] = 'StrandoftheAncients',
	["Warsong Gulch"] = 'WarsongGulch',
	["Isle of Conquest"] = 'Isleofconquest',
}

YssInstanceMaps.Maps.rDungeon = {}
for k, v in pairs(YssInstanceMaps.Maps.Dungeon) do
	YssInstanceMaps.Maps.rDungeon[v] = k
end
YssInstanceMaps.Maps.rRaid = {}
for k, v in pairs(YssInstanceMaps.Maps.Raid) do
	YssInstanceMaps.Maps.rRaid[v] = k
end
YssInstanceMaps.Maps.rBattlegrounds = {}
for k, v in pairs(YssInstanceMaps.Maps.Battlegrounds) do
	YssInstanceMaps.Maps.rBattlegrounds[v] = k
end

------------------------------------------------------------
----------------------Map Levels----------------------------
------------------------------------------------------------
YssInstanceMaps.Levels = {}
YssInstanceMaps.Levels.Dungeon = {
	["Ahn'kahet: The Old Kingdom"] = 2,
	["Azjol-Nerub"] = 3,
	["Drak'Tharon Keep"] = 2,
	["Gundrak"] = 1,
	["Halls of Lightning"] = 2,
	["Halls of Stone"] = 1,
	["The Culling of Stratholme"] = {0,1},
	["The Nexus"] = 1,
	["The Oculus"] = 4,
	["The Violet Hold"] = 1,
	["Utgarde Keep"] = 3,
	["Utgarde Pinnacle"] = 2,
	["Trial of the Champion"] = 1,
	["The Forge of Souls"] = 1,
	["Pit of Saron"] = 0,
	["Halls of Reflection"] = 1,
}

YssInstanceMaps.Levels.Raid = {
	["Icecrown Citadel"] = 8,
	["Naxxramas"] = {5,1,2,3,4,6},
	["The Eye of Eternity"] = 1,
	["The Obsidian Sanctum"] = 0,
	["Ulduar"] = {0,1,2,4,3,5},
	["Vault of Archavon"] = 1,
	["Trial of the Crusader"] = 2,
}

YssInstanceMaps.Levels.Battlegrounds = {
	["Alterac Valley"] = 0,
	["Arathi Basin"] = 0,
	["Eye of the Storm"] = 0,
	["Strand of the Ancients"] = 0,
	["Warsong Gulch"] = 0,
	["Isle of Conquest"] = 0,
}

------------------------------------------------------------
-------------------------Map Bosses-------------------------
------------------------------------------------------------
YssInstanceMaps.Bosses = {}
YssInstanceMaps.Bosses.Dungeon = { -- format is maplevel1:map1X:map1Y|maplevel2:map2X:map2Y...
	["Ahn'kahet: The Old Kingdom"] = {
		["Amanitar"]="1:6685:7842",
		["Elder Nadox"]="1:6928:2744",
		["Herald Volazj"]="1:2362:5056|2:3992:5117",
		["Jedoga Shadowseeker"]="1:4827:7343|2:6749:7586",
		["Prince Taldaram"]="1:6279:4959",
	},
	["Drak'Tharon Keep"] = {
		["King Dred"]="1:6093:8657",
		["Novos the Summoner"]="1:6960:4740",
		["The Prophet Tharon'ja"]="2:4754:1345",
		["Trollgore"]="1:5663:1795",
	},
	["Azjol-Nerub"] = {
		["Anub'arak"]="3:5027:4470",
		["Hadronox"]="2:4335:5919",
		["Krik'thir the Gatewatcher"]="1:6203:4839",
	},
	["Gundrak"] = {
		["Drakkari Elemental"]="1:4649:6540",
		["Eck the Ferocious"]="1:2532:7015",
		["Gal'darah"]="1:4657:2781",
		["Moorabi"]="1:3959:4934",
		["Slad'ran"]="1:5372:4886",
	},
	["Halls of Lightning"] = {
		["General Bjarngrim"]="1:4357:3705",
		["Ionar"]="2:6101:7757",
		["Loken"]="2:1924:5202",
		["Volkhan"]="2:3765:2124",
	},
	["Halls of Stone"] = {
		["Krystallus"]="1:4000:6066",
		["Maiden of Grief"]="1:5014:8621",
		["Sjonnir The Ironshaper"]="1:4989:1333",
		["Tribunal of Ages"]="1:8477:7623",
	},
	["The Culling of Stratholme"] = {
		["Chrono-Lord Epoch"]="1:6571:2550",
		["Infinite Corruptor"]="1:5176:4156",
		["Mal'Ganis"]="1:3229:4606",
		["Meathook"]="1:6166:4898",
		["Salramm the Fleshcrafter"]="1:4681:6017",
	},
	["The Nexus"] = {
		["Anomalus"]="1:6149:2185",
		["Commander Stoutbeard"]="1:1899:5080",
		["Grand Magus Telestra"]="1:2751:4022",
		["Keristrasza"]="1:3611:6771",
		["Ormorok the Tree-Shaper"]="1:5622:7282",
	},
	["The Oculus"] = {
		["Drakos the Interrogator"]="1:4892:7586",
		["Ley-Guardian Eregos"]="4:4714:2087",
		["Mage-Lord Urom"]="3:7066:2756",
		["Varos Cloudstrider"]="2:4608:1917",
	},
	["The Violet Hold"] = {
		["Cyanigosa"]="1:4576:5579",
		["Erekem"]="1:2459:6297",
		["Ichoron"]="1:5598:3961",
		["Lavanthor"]="1:6271:7635",
		["Moragg"]="1:7033:5190",
		["Xevozz"]="1:3343:4691",
		["Zuramat the Obliterator"]="1:2840:3486",
	},
	["Utgarde Keep"] = {
		["Dalronn the Controller"]="2:5825:6139",
		["Skarvald the Constructor"]="3:7228:3803",
		["Prince Keleseth"]="1:2881:6272",
	},
	["Utgarde Pinnacle"] = {
		["Gortok Palehoof"]="2:6060:6893",
		["King Ymiron"]="2:4097:5348",
		["Skadi the Ruthless"]="2:6863:3645",
		["Svala Sorrowgrave"]="1:3619:6990",
	},
	["Trial of the Champion"] = {
		["Grand Champions"] = "1:5103:6424",
		["Eadric the Pure"] = "1:6003:5274",
		["Argent Confessor Paletress"] = "1:4203:5274",
		["The Black Knight"] = "1:5103:4124",
	},
	["The Forge of Souls"] = {
		["Bronjahm, the Godfather of Souls"] = "1:4349:4995",
		["The Devourer of Souls"] = "1:4365:1260",
	},
	["Pit of Saron"] = {
		["Forgemaster Garfrost"] = "0:6766:5518",
		["Krick and Ick"] = "0:4738:4034",
		["Scourgelord Tyrannus"] = "0:4414:2623",
	},
	["Halls of Reflection"] = {
		["Falric and Marwyn"] = "1:1007:2756",
		["Boss 2"] = "1:4284:6285",
		["Boss 3"] = "1:3497:7501",
	},
}

YssInstanceMaps.Bosses.Raid = {
	["Icecrown Citadel"] = {
		["Lord Marrowgar"] = "1:3896:6002",
		["Lady Deathwhisper"] = "1:3896:8671",
		["The Deathbringer"] = "3:5134:2192",
		["Sindragosa"] = "4:3656:2338",
		["Blood Prince Council"] = "5:5184:1444",
		["Festergut"] = "5:1980:4196",
		["Professor Putricide"] = "5:1324:5366",
		["Rotface"] = "5:1980:6550",
		["Valithiria Dreamwalker"] = "5:7668:7386",
		["Queen Lana'thel"] = "6:5114:4396",
		["The Lich King"] = "7:4984:5292",
	},
	["The Eye of Eternity"] = {
		["Malygos"] = "1:3853:5000",
	},
	["The Obsidian Sanctum"] = {
		["Sartharion"] = "0:5051:4779",
		["Tenebron"] = "0:4157:4818",
		["Shadron"] = "0:5198:3321",
		["Vesperon"] = "0:5303:6198",
	},
	["Vault of Archavon"] = {
		["Archavon the Stone Watcher"] = "1:5095:1856",
		["Emalon the Storm Watcher"] = "1:7171:4898",
		["Koralon the Flame Watcher"] = "1:3059:4898",
	},
	["Naxxramas"] = {
		["Patchwerk"] = "1:5395:4216|5:4311:2656",
		["Grobbulus"] = "1:6166:5275|5:4737:3241",
		["Gluth"] = "1:4584:4423|5:3863:2771",
		["Thaddius"] = "1:2645:1503|5:2792:1158",

		["Anub'Rekhan"] = "2:3059:4703|5:5517:2933",
		["Grand Widow Faerlina"] = "2:4397:3620|5:6257:2335",
		["Maexxna"] = "2:6847:1552|5:7610:1193",
		
		["Instructor Razuvious"] = "3:4268:4581|5:3647:6783",
		["Gothik the Harvester"] = "3:6741:5980|5:5135:7625",
		["The Four Horsemen"] = "3:3019:7696|5:2895:8658",
		
		["Noth the Plaguebringer"] = "4:3465:5664|5:5692:7394",
		["Heigan the Unclean"] = "4:4973:4581|5:6599:6742",
		["Loatheb"] = "4:7569:2866|5:8162:5710",

		["Sapphiron"] = "6:5663:6759",
		["Kel'Thuzad"] = "6:3659:2270",
	},
	["Ulduar"] = {
		["Flame Leviathan"] = "0:4925:3888",
		["Razorscale"] = "0:5436:2683",
		["Ignis the Furnace Master"] = "0:3830:2671",
		["XT-002 Deconstructor"] = "0:4852:1455",
		
		["Assembly of Iron"] = "1:1550:5701",
		["Kologarn"] = "1:3724:1248",
		["Algalon the Observer"] = "1:7917:4630",
		
		["Auriaya"] = "2:5119:5701",
		["Hodir"] = "2:6693:6406",
		["Thorim"] = "2:7187:4873",
		["Freya"] = "2:5322:2306",
		
		["Mimiron"] = "4:4357:4143",
		
		["General Vezax"] = "3:5687:6066",
		["Yogg-Saron"] = "3:6806:4070|5:5395:6467",
	},
	["Trial of the Crusader"] = {
		["Northrend Beasts"] = "1:5103:6424",
		["Lord Jaraxxus"] = "1:4203:5274",
		["Faction Champions"] = "1:6003:5274",
		["Twin Val'kyr"] = "1:5103:4124",
		["Anub'arak"] = "2:5306:3535",
	},
}